.Const

.Data

hInst			DD			NULL
hWindow			DD			NULL
lTimers			DD			0
lpTimerIDs		DD			NULL

szTimerClass	DB			'EasyCodeTimerClass', 0

timecaps		TIMECAPS	<0>


.Code

start:

DllEntryPoint Frame hInstance, dwReason, lpvReserved
	Local wc:WNDCLASSEX

	Cmp D[dwReason], DLL_PROCESS_ATTACH
	Jne >>
	Mov Eax, [hInstance]
	Mov [hInst], Eax

	Mov [wc.hInstance], Eax
	Mov D[wc.cbSize], SizeOf WNDCLASSEX
	Mov D[wc.style], 0
	Mov [wc.lpfnWndProc], Offset TimerWindow
	Mov D[wc.cbClsExtra], 0
	Mov D[wc.cbWndExtra], 0
	Mov D[wc.hIcon], NULL
	Mov D[wc.hCursor], NULL
	Mov D[wc.hbrBackground], NULL
	Mov D[wc.lpszMenuName], NULL
	Mov [wc.lpszClassName], Offset szTimerClass
	Mov D[wc.hIconSm], NULL
	Invoke RegisterClassEx, Addr wc

	Invoke GlobalAlloc, GPTR, 1024
	Mov [lpTimerIDs], Eax

	Invoke CreateWindowEx, 0, Addr szTimerClass, NULL, 0, 0, 0, 0, 0, NULL, NULL, [hInst], NULL
	Mov [hWindow], Eax

	Invoke timeGetDevCaps, Addr timecaps, SizeOf (timecaps)
	Invoke timeBeginPeriod, [timecaps.wPeriodMin]
	Jmp > L2

:	Cmp D[dwReason], DLL_PROCESS_DETACH
	Jne >
	Invoke DestroyWindow, [hWindow]
	Call DestroyTimers
	Invoke timeEndPeriod, [timecaps.wPeriodMin]
	Jmp > L2

:	Cmp D[dwReason], DLL_THREAD_ATTACH
	Jne >

	Jmp > L2

:	Cmp D[dwReason], DLL_THREAD_DETACH
	Jne > L2

L2:	Return (TRUE)
EndF

DestroyTimers:
	Uses Esi
	Mov Esi, [lpTimerIDs]
:	Mov Eax, [Esi]
	Or Eax, Eax
	Jz >
	Invoke timeKillEvent, Eax
	Add Esi, 8
	Jmp <
:	Invoke GlobalFree, [lpTimerIDs]
	Ret
EndU

GetUserProcAddress Frame uID Uses Esi
	Mov Esi, [lpTimerIDs]
	Mov Eax, [uID]
L2:	Cmp D[Esi], 0
	Jne >
	Xor Eax, Eax
	Ret
:	Cmp [Esi], Eax
	Je >
	Add Esi, 8
	Jmp < L2
:	Mov Eax, [Esi + 4]
	Ret
EndF

ReallocateTimerIDs Frame uID Uses Edx, Esi
	Mov Esi, [lpTimerIDs]
	Mov Eax, [uID]
L2:	Cmp D[Esi], 0
	Jne >
	Ret
:	Cmp [Esi], Eax
	Je >
	Add Esi, 8
	Jmp < L2
:	Mov Edx, Esi
	Mov D[Edx], 0
	Mov D[Edx + 4], 0
:	Add Esi, 8
	Cmp D[Esi], 0
	Je >
	Mov Eax, [Esi]
	Mov [Edx], Eax
	Mov Eax, [Esi + 4]
	Mov [Edx + 4], Eax
	Add Edx, 8
	Jmp <
:	Mov D[Edx], 0
	Add D[Edx + 4], 0
	Ret
EndF

SaveTimerID Frame uID, dwProcAddress Uses Eax, Esi
	Mov Esi, [lTimers]
	Shl Esi, 3
	Add Esi, [lpTimerIDs]
	Mov Eax, [uID]
	Mov [Esi], Eax
	Mov Eax, [dwProcAddress]
	Mov [Esi + 4], Eax
	Inc D[lTimers]
	Ret
EndF

TimerEvents Frame uID, uMsg, dwUser, dw1, dw2
	Invoke PostMessage, [hWindow], (WM_USER + 300), 0, [uID]
	Ret
EndF

TimerWindow Frame hWnd, uMsg, wParam, lParam
	Cmp D[uMsg], (WM_USER + 300)
	Jne >
	Invoke GetUserProcAddress, [lParam]
	Push [lParam]
	Call Eax
	Ret
:	Invoke DefWindowProc, [hWnd], [uMsg], [wParam], [lParam]
	Ret
EndF

StopTimer Frame uID
	Cmp D[lTimers], 0
	Jne > L4
:	Xor Eax, Eax
	Ret
L4:	Invoke timeKillEvent, [uID]
	Cmp Eax, TIMERR_NOERROR
	Jne <
	Invoke ReallocateTimerIDs, [uID]
	Cmp D[lTimers], 0
	Jle >
	Dec D[lTimers]
:	Mov Eax, TRUE
	Ret
EndF

Export BeginTimer Frame lInterval, dwProcAddress
	Cmp D[dwProcAddress], NULL
	Jne > L2
:	Xor Eax, Eax
	Ret
L2:	Cmp D[lInterval], 0
	Jle <
	Cmp D[lTimers], 127
	Jge <
	Invoke timeSetEvent, [lInterval], [timecaps.wPeriodMin], Addr TimerEvents, NULL, (TIME_PERIODIC Or TIME_CALLBACK_FUNCTION)
	Or Eax, Eax
	Jz >
	Invoke SaveTimerID, Eax, [dwProcAddress]
:	Ret
EndF

Export EndTimer Frame uID
	Invoke StopTimer, [uID]
	Ret
EndF

Export GetMinPeriod:
	Mov Eax, [timecaps.wPeriodMin]
	Ret

Export GetMaxPeriod:
	Mov Eax, [timecaps.wPeriodMax]
	Ret
